var EventEmitter = require('sk/core/events').EventEmitter;

exports.object = function(value, Model)
{

	var listeners = [];

	var func = function(v)
	{
		if(v == undefined || v == value) return value;

		if(Model && v.__construct != Model) v = new Model(v);

		for(var i = listeners.length; i--;)
		{
			listeners[i](v);
		}

		value = v;

		return v;
	}

	func.subscribe = function(callback)
	{
		listeners.push(callback);	

		return {
			dispose: function()
			{
				var i = listeners.indexOf(callback);
				if(i > -1) listeners.splice(i, 1);
			}
		}
	}

	func.subscribeOnce = function(callback)
	{
		var disp,
		onChange = function()
		{
			callback.apply(null, arguments);
			disp.dispose();
		};

		return disp = func.subscribe(onChange);
	}

	func.bind = function(callback)
	{
		var disp = func.subscribe(callback);
		callback(func());
		return disp;
	}

	func.dispose = function()
	{
		listeners = [];
	}


	return func;
}


/*exports.collection = function(target)
{
	
}*/