var beanpole = require('beanpole'),
hookBean = require('beanpole/core/beans/hook.core'),
hookHttpBean = require('beanpole/node/beans/hook.http'),
socketBean = require('beanpole/web/beans/hook.socket.io'),
models = require('./models');

require('sk/node/log')


models.Stream = models.Collection.extend({

	'override __construct': function(uri)
	{
		this._super( { uri: uri });	
	},

	_channel: function()
	{
		return this.uri();
	}
});


exports._initModels = function(router)
{
	var hostModels = {};

	for(var name in models)
	{
		var model = models[name];

		if(!model.extend) continue;

		//extend the model since there may be additional connections 
		var newModel = model.extend({ router: router });


		newModel.all = function()
		{
			
		}


		//static methods
		for(var property in model)
		{
			if(property == 'extend') continue;

			newModel[property] = model[property];
		}

		hostModels[name] = newModel;
	}

	return hostModels;
}


exports.connect = function(host, onConnect)
{
	var router = beanpole.router();

	router.model = exports._initModels(router);

	hookBean.plugin(router);
	hookHttpBean.plugin(router);

	if(onConnect) router.on('push -one -public spice.io/ready', onConnect)

	router.push('init');

	return router;
}

var cliqly = exports.connect('cliqly.spice.io', function()
{
	var str = new cliqly.model.Stream('/stream/twitter/search/google');
	str.sync();
});



